/* Copyright 2009-2013 David Hadka
 *
 * This file is part of the MOEA Framework.
 *
 * The MOEA Framework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * The MOEA Framework is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with the MOEA Framework.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.moeaframework.analysis.diagnostics;

import java.awt.Color;

/**
 * Placeholder in a layout for unoccupied grid locations.
 */
public class EmptyPlot extends ResultPlot {

	private static final long serialVersionUID = 2426493357932914320L;

	/**
	 * Constructs a placeholder plot.
	 * 
	 * @param frame the {@code DiagnosticTool} instance containing this plot
	 */
	public EmptyPlot(DiagnosticTool frame) {
		super(frame, null);
		
		setBackground(Color.WHITE);
	}
	
	@Override
	protected void update() {
		//do nothing
	}

}
